pipeline {  
    agent any  
        environment {
        APPROVAL_REQUIRED = true
    }

          stages {  
       	    stage('pullcode') {  
           	  steps {  
                git credentialsId: 'gitlab_token', url: 'https://gitlab.com/fineshift/users/devsecops/jenkins-bookstore.git'
              	    }  
         	  } 
          stage('Branch Check') {
            when { expression { env.BRANCH_NAME == 'origin/jenkins_demo' && env.APPROVAL_REQUIRED } }
            steps {
                script {
                    env.APPROVAL_REQUIRED = false
                    next('Wait for Approval')
                }
            }
        } 
        
            stage('build') {  
           	  steps {
                sh "mvn clean package"
                sh "echo ${GIT_BRANCH}"
                sh "echo ${BUILD_ID}"
              	    } 
            }  
            
            stage('artifacts'){
              steps{
                sh '''
                        curl --header "PRIVATE-TOKEN: glpat-JadNruYvg2ioxxHbhzhq" \
                        --upload-file ${WORKSPACE}/target/onlinebookstore.war \
                        "https://gitlab.com/api/v4/projects/54941683/packages/generic/${GIT_BRANCH}/${BUILD_ID}/onlinebookstore.war"
                    '''
              }
            }
            stage('Test') {
              steps('SonarQube Analysis') {
                withSonarQubeEnv('sonarserver') {
                    sh "mvn clean verify sonar:sonar -Dsonar.projectKey=jenkins-onlinebookstore"
                  }
                }
              }
              
            //stage('Upload-Artifacts') {
              //steps {
                //jf '-v' 
                //jf 'c show'
                //jf 'rt ping'
                //dir('/var/lib/jenkins/workspace/onlinebookstore_jenkins_demo/target/')
                  //sh 'pwd'
                  //jf 'rt u onlinebookstore.war my-repo/'
                  //sh 'sudo touch test-file'
                  //jf 'rt u test-file my-repo/'
                  //jf 'rt bp'
                  //jf 'rt dl my-repo/onlinebookstore.war'
              //}
            //}


         stage('Wait for Approval') {
        when { expression { true} }
        steps {
            timeout(time: 5, unit: 'DAYS') {
                input message: 'Approve deployment?'
            }
        }
        post {
            always {
                script {
                    def approval = input(id: 'userInput', message: 'Approve deployment?', parameters: [booleanParam(defaultValue: false, description: 'Approve deployment?', name: 'APPROVE')])
                    if (!approval) {
                        error("Deployment not approved. Aborting the pipeline.")
                    }
                }
            }

        }
    }

            stage('Deploy') {
              steps {
                sh '''
                    cd target
                    rm -r onlinebookstore.war
                    curl --header curl --header "PRIVATE-TOKEN: glpat-JadNruYvg2ioxxHbhzhq" -O "https://gitlab.com/api/v4/projects/54941683/packages/generic/${GIT_BRANCH}/${BUILD_ID}/onlinebookstore.war"
                    cd ..

                '''
                deploy adapters: [tomcat9(credentialsId: 'TomJen', path: '', url: 'http://18.212.61.229:8181//mnt/volume/stage-env/webapps/')], contextPath: null, war: '**/target/onlinebookstore.war'

                sh "rm -r target"
              }
            }
            
            
            stage('owasp-zap') {
              steps {
                script {
              try {
                sh '''sudo docker run -u 0 --network host -v /mnt/volume/zap:/zap/wrk/:rw owasp/zap2docker-stable zap-full-scan.py -t http://18.212.61.229:8181/onlinebookstore/ -J report.json -r report.html'''
              }
            catch (err) {
                echo err.getMessage()
              }
            }
          }
        }
      }    
    }

